package service

import (
	"context"
	"time"
	"youngee_b_api/db"
	"youngee_b_api/model/gorm_model"
	"youngee_b_api/model/http_model"

	log "github.com/sirupsen/logrus"
)

var Enterprise *enterprise

type enterprise struct {
}

func (*enterprise) CreateEnterpriseUser(ctx context.Context, newEnterprise http_model.RegisterRequest) (*http_model.RegisterData, error) {
	user := gorm_model.User{
		Phone:         newEnterprise.Phone,
		User:          "1001",
		Username:      newEnterprise.BusinessName,
		Password:      "1001",
		RealName:      newEnterprise.RealName,
		Role:          "3",
		Email:         newEnterprise.Email,
		LastLogintime: time.Now().UTC().Local(),
	}
	userId, err := db.CreateUser(ctx, user)
	if err != nil {
		log.Infof("[CreateEnterpriseUser] fail,err:%+v", err)
		return nil, err
	} else {
		enterprise := &gorm_model.Enterprise{
			Industry:         newEnterprise.Industry,
			BusinessName:     newEnterprise.BusinessName,
			UserID:           *userId,
			Balance:          0,
			FrozenBalance:    0,
			AvailableBalance: 0,
		}
		enterpriseId, err := db.CreateEnterprise(ctx, *enterprise)
		if err != nil {
			log.Infof("[CreateEnterpriseUser] fail,err:%+v", err)
			return nil, err
		}
		res := &http_model.RegisterData{
			EnterpriseId: *enterpriseId,
			UserID:       *userId,
		}
		return res, nil
	}
}
